package edu.berkeley.sbp;
import edu.berkeley.sbp.*;
import edu.berkeley.sbp.*;
import edu.berkeley.sbp.util.*;
import java.io.*;
import java.util.*;
import java.lang.reflect.*;

/** a tree (or node in a tree); see jargon.txt for details */
public class Tree<T> extends PrintableTree<Tree<T>> implements Iterable<Tree<T>> {

    final T           head;
          Tree<T>[]   children;
    final Token.Location    location;

    public T                 head()        { return head; }
    public int               numChildren() { return children.length; }
    public Iterable<Tree<T>> children()    { return new ArrayIterator(children); }
    public Iterator<Tree<T>> iterator()    { return new ArrayIterator(children); }
    public Tree<T>           child(int i)  { return children[i]; }

    public       Token.Location    getLocation() { return location; }

    public Tree(Token.Location loc, T head)                   { this(loc, head, null); }
    public Tree(Token.Location loc, T head, Tree<T>[] children) {
        this.location = loc;
        this.head = head;
        Tree<T>[] children2 = children==null ? new Tree[0] : new Tree[children.length];
        if (children != null) System.arraycopy(children, 0, children2, 0, children.length);
        this.children = children2;
    }

    protected String headToString() { return head==null?null:head.toString(); }
    protected String headToJava()   { return head==null?null:StringUtil.toJavaString(head+""); }
}
